package com.hfkj.dao;

import com.hfkj.entity.BsOrderDeduction;
import com.hfkj.entity.BsOrderDeductionExample.Criteria;
import com.hfkj.entity.BsOrderDeductionExample.Criterion;
import com.hfkj.entity.BsOrderDeductionExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsOrderDeductionSqlProvider {

    public String countByExample(BsOrderDeductionExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_order_deduction");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsOrderDeductionExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_order_deduction");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsOrderDeduction record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_order_deduction");
        
        if (record.getOrderId() != null) {
            sql.VALUES("order_id", "#{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.VALUES("total_deduction_price", "#{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getUserCouponDiscountId() != null) {
            sql.VALUES("user_coupon_discount_id", "#{userCouponDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponDiscountId() != null) {
            sql.VALUES("coupon_discount_id", "#{couponDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponDiscountNo() != null) {
            sql.VALUES("coupon_discount_no", "#{couponDiscountNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponDiscountType() != null) {
            sql.VALUES("coupon_discount_type", "#{couponDiscountType,jdbcType=INTEGER}");
        }
        
        if (record.getCouponDiscountPrice() != null) {
            sql.VALUES("coupon_discount_price", "#{couponDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponDiscountActualPrice() != null) {
            sql.VALUES("coupon_discount_actual_price", "#{couponDiscountActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDiscountPrice() != null) {
            sql.VALUES("integral_discount_price", "#{integralDiscountPrice,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsOrderDeductionExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("order_id");
        sql.SELECT("order_no");
        sql.SELECT("total_deduction_price");
        sql.SELECT("user_coupon_discount_id");
        sql.SELECT("coupon_discount_id");
        sql.SELECT("coupon_discount_no");
        sql.SELECT("coupon_discount_type");
        sql.SELECT("coupon_discount_price");
        sql.SELECT("coupon_discount_actual_price");
        sql.SELECT("integral_discount_price");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_order_deduction");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsOrderDeduction record = (BsOrderDeduction) parameter.get("record");
        BsOrderDeductionExample example = (BsOrderDeductionExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_order_deduction");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getUserCouponDiscountId() != null) {
            sql.SET("user_coupon_discount_id = #{record.userCouponDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponDiscountId() != null) {
            sql.SET("coupon_discount_id = #{record.couponDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponDiscountNo() != null) {
            sql.SET("coupon_discount_no = #{record.couponDiscountNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponDiscountType() != null) {
            sql.SET("coupon_discount_type = #{record.couponDiscountType,jdbcType=INTEGER}");
        }
        
        if (record.getCouponDiscountPrice() != null) {
            sql.SET("coupon_discount_price = #{record.couponDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponDiscountActualPrice() != null) {
            sql.SET("coupon_discount_actual_price = #{record.couponDiscountActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDiscountPrice() != null) {
            sql.SET("integral_discount_price = #{record.integralDiscountPrice,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_deduction");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("order_id = #{record.orderId,jdbcType=BIGINT}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("total_deduction_price = #{record.totalDeductionPrice,jdbcType=DECIMAL}");
        sql.SET("user_coupon_discount_id = #{record.userCouponDiscountId,jdbcType=BIGINT}");
        sql.SET("coupon_discount_id = #{record.couponDiscountId,jdbcType=BIGINT}");
        sql.SET("coupon_discount_no = #{record.couponDiscountNo,jdbcType=VARCHAR}");
        sql.SET("coupon_discount_type = #{record.couponDiscountType,jdbcType=INTEGER}");
        sql.SET("coupon_discount_price = #{record.couponDiscountPrice,jdbcType=DECIMAL}");
        sql.SET("coupon_discount_actual_price = #{record.couponDiscountActualPrice,jdbcType=DECIMAL}");
        sql.SET("integral_discount_price = #{record.integralDiscountPrice,jdbcType=BIGINT}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsOrderDeductionExample example = (BsOrderDeductionExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsOrderDeduction record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_order_deduction");
        
        if (record.getOrderId() != null) {
            sql.SET("order_id = #{orderId,jdbcType=BIGINT}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getTotalDeductionPrice() != null) {
            sql.SET("total_deduction_price = #{totalDeductionPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getUserCouponDiscountId() != null) {
            sql.SET("user_coupon_discount_id = #{userCouponDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponDiscountId() != null) {
            sql.SET("coupon_discount_id = #{couponDiscountId,jdbcType=BIGINT}");
        }
        
        if (record.getCouponDiscountNo() != null) {
            sql.SET("coupon_discount_no = #{couponDiscountNo,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponDiscountType() != null) {
            sql.SET("coupon_discount_type = #{couponDiscountType,jdbcType=INTEGER}");
        }
        
        if (record.getCouponDiscountPrice() != null) {
            sql.SET("coupon_discount_price = #{couponDiscountPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getCouponDiscountActualPrice() != null) {
            sql.SET("coupon_discount_actual_price = #{couponDiscountActualPrice,jdbcType=DECIMAL}");
        }
        
        if (record.getIntegralDiscountPrice() != null) {
            sql.SET("integral_discount_price = #{integralDiscountPrice,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsOrderDeductionExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}